Nota
L'accesso a questa pagina richiede l'autorizzazione. È possibile provare ad accedere o modificare le directory.
L'accesso a questa pagina richiede l'autorizzazione. È possibile provare a modificare le directory.
API Version: v1
Server: {endpoint} — Microsoft Foundry
Server Variables:
| Variable | Default | Description |
|---|---|---|
| endpoint | Foundry Project endpoint in the form "https://{ai-services-account-name}.services.ai.azure.com/api/projects/{project-name}". If you only have one Project in your Foundry Hub, or to target the default Project in your Hub, use the form "https://{ai-services-account-name}.services.ai.azure.com/api/projects/_project" |
Authentication
OAuth2Auth (OAuth 2.0)
Flow: implicit
Authorization URL: https://login.microsoftonline.com/common/oauth2/v2.0/authorize
Scopes:
https://ai.azure.com/.default
Security Requirements
All endpoints require OAuth2Auth (scopes: https://ai.azure.com/.default).
Agents - create agent
POST {endpoint}/agents?api-version=v1
Creates the agent.
URI Parameters
| Name | In | Required | Type | Description |
|---|---|---|---|---|
| endpoint | server | Yes | string | Foundry Project endpoint in the form "https://{ai-services-account-name}.services.ai.azure.com/api/projects/{project-name}". If you only have one Project in your Foundry Hub, or to target the default Project in your Hub, use the form "https://{ai-services-account-name}.services.ai.azure.com/api/projects/_project" |
| api-version | query | Yes | string | The API version to use for this operation. Serialization: explode: false |
Request Header
| Name | Required | Type | Description |
|---|---|---|---|
| Foundry-Features | No | string Possible values: HostedAgents=V1Preview, WorkflowAgents=V1Preview |
A feature flag opt-in required when using preview operations or modifying persisted preview resources. |
Request Body
Content-Type: application/json
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| definition | AgentDefinition | Yes | ||
| └─ kind | AgentKind | Yes | ||
| └─ rai_config | RaiConfig | Configuration for Responsible AI (RAI) content filtering and safety features. | No | |
| description | string | A human-readable description of the agent. Constraints: maxLength: 512 |
No | |
| metadata | object | Set of 16 key-value pairs that can be attached to an object. This can be useful for storing additional information about the object in a structured format, and querying for objects via API or the dashboard. Keys are strings with a maximum length of 64 characters. Values are strings with a maximum length of 512 characters. |
No | |
| name | string | The unique name that identifies the agent. Name can be used to retrieve/update/delete the agent. - Must start and end with alphanumeric characters, - Can contain hyphens in the middle - Must not exceed 63 characters. Constraints: maxLength: 63 |
Yes |
Responses
Status Code: 200
Description: The request has succeeded.
| Content-Type | Type | Description |
|---|---|---|
| application/json | AgentObject |
Status Code: default
Description: An unexpected error response.
| Content-Type | Type | Description |
|---|---|---|
| application/json | ApiErrorResponse |
Agents - list agents
GET {endpoint}/agents?api-version=v1
Returns the list of all agents.
URI Parameters
| Name | In | Required | Type | Description |
|---|---|---|---|---|
| endpoint | server | Yes | string | Foundry Project endpoint in the form "https://{ai-services-account-name}.services.ai.azure.com/api/projects/{project-name}". If you only have one Project in your Foundry Hub, or to target the default Project in your Hub, use the form "https://{ai-services-account-name}.services.ai.azure.com/api/projects/_project" |
| kind | query | No | string Possible values: prompt, hosted, workflow |
Filter agents by kind. If not provided, all agents are returned. Serialization: explode: false |
| limit | query | No | integer (int32) | A limit on the number of objects to be returned. Limit can range between 1 and 100, and the default is 20. Serialization: explode: false |
| order | query | No | string Possible values: asc, desc |
Sort order by the created_at timestamp of the objects. asc for ascending order anddescfor descending order. Serialization: explode: false |
| after | query | No | string | A cursor for use in pagination. after is an object ID that defines your place in the list.For instance, if you make a list request and receive 100 objects, ending with obj_foo, your subsequent call can include after=obj_foo in order to fetch the next page of the list. Serialization: explode: false |
| before | query | No | string | A cursor for use in pagination. before is an object ID that defines your place in the list.For instance, if you make a list request and receive 100 objects, ending with obj_foo, your subsequent call can include before=obj_foo in order to fetch the previous page of the list. Serialization: explode: false |
| api-version | query | Yes | string | The API version to use for this operation. Serialization: explode: false |
Responses
Status Code: 200
Description: The request has succeeded.
| Content-Type | Type | Description |
|---|---|---|
| application/json | object | The response data for a requested list of items. |
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| data | array of AgentObject | The requested list of items. | Yes | |
| first_id | string | The first ID represented in this list. | No | |
| has_more | boolean | A value indicating whether there are additional values available not captured in this list. | Yes | |
| last_id | string | The last ID represented in this list. | No |
Status Code: default
Description: An unexpected error response.
| Content-Type | Type | Description |
|---|---|---|
| application/json | ApiErrorResponse |
Agents - get agent
GET {endpoint}/agents/{agent_name}?api-version=v1
Retrieves the agent.
URI Parameters
| Name | In | Required | Type | Description |
|---|---|---|---|---|
| endpoint | server | Yes | string | Foundry Project endpoint in the form "https://{ai-services-account-name}.services.ai.azure.com/api/projects/{project-name}". If you only have one Project in your Foundry Hub, or to target the default Project in your Hub, use the form "https://{ai-services-account-name}.services.ai.azure.com/api/projects/_project" |
| agent_name | path | Yes | string | The name of the agent to retrieve. |
| api-version | query | Yes | string | The API version to use for this operation. Serialization: explode: false |
Responses
Status Code: 200
Description: The request has succeeded.
| Content-Type | Type | Description |
|---|---|---|
| application/json | AgentObject |
Status Code: default
Description: An unexpected error response.
| Content-Type | Type | Description |
|---|---|---|
| application/json | ApiErrorResponse |
Agents - update agent
POST {endpoint}/agents/{agent_name}?api-version=v1
Updates the agent by adding a new version if there are any changes to the agent definition. If no changes, returns the existing agent version.
URI Parameters
| Name | In | Required | Type | Description |
|---|---|---|---|---|
| endpoint | server | Yes | string | Foundry Project endpoint in the form "https://{ai-services-account-name}.services.ai.azure.com/api/projects/{project-name}". If you only have one Project in your Foundry Hub, or to target the default Project in your Hub, use the form "https://{ai-services-account-name}.services.ai.azure.com/api/projects/_project" |
| agent_name | path | Yes | string | The name of the agent to retrieve. |
| api-version | query | Yes | string | The API version to use for this operation. Serialization: explode: false |
Request Header
| Name | Required | Type | Description |
|---|---|---|---|
| Foundry-Features | No | string Possible values: HostedAgents=V1Preview, WorkflowAgents=V1Preview |
A feature flag opt-in required when using preview operations or modifying persisted preview resources. |
Request Body
Content-Type: application/json
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| definition | AgentDefinition | Yes | ||
| └─ kind | AgentKind | Yes | ||
| └─ rai_config | RaiConfig | Configuration for Responsible AI (RAI) content filtering and safety features. | No | |
| description | string | A human-readable description of the agent. Constraints: maxLength: 512 |
No | |
| metadata | object | Set of 16 key-value pairs that can be attached to an object. This can be useful for storing additional information about the object in a structured format, and querying for objects via API or the dashboard. Keys are strings with a maximum length of 64 characters. Values are strings with a maximum length of 512 characters. |
No |
Responses
Status Code: 200
Description: The request has succeeded.
| Content-Type | Type | Description |
|---|---|---|
| application/json | AgentObject |
Status Code: default
Description: An unexpected error response.
| Content-Type | Type | Description |
|---|---|---|
| application/json | ApiErrorResponse |
Agents - delete agent
DELETE {endpoint}/agents/{agent_name}?api-version=v1
Deletes an agent.
URI Parameters
| Name | In | Required | Type | Description |
|---|---|---|---|---|
| endpoint | server | Yes | string | Foundry Project endpoint in the form "https://{ai-services-account-name}.services.ai.azure.com/api/projects/{project-name}". If you only have one Project in your Foundry Hub, or to target the default Project in your Hub, use the form "https://{ai-services-account-name}.services.ai.azure.com/api/projects/_project" |
| agent_name | path | Yes | string | The name of the agent to delete. |
| api-version | query | Yes | string | The API version to use for this operation. Serialization: explode: false |
Responses
Status Code: 200
Description: The request has succeeded.
| Content-Type | Type | Description |
|---|---|---|
| application/json | DeleteAgentResponse |
Status Code: default
Description: An unexpected error response.
| Content-Type | Type | Description |
|---|---|---|
| application/json | ApiErrorResponse |
Agents - update agent from manifest
POST {endpoint}/agents/{agent_name}/import?api-version=v1
Updates the agent from a manifest by adding a new version if there are any changes to the agent definition. If no changes, returns the existing agent version.
URI Parameters
| Name | In | Required | Type | Description |
|---|---|---|---|---|
| endpoint | server | Yes | string | Foundry Project endpoint in the form "https://{ai-services-account-name}.services.ai.azure.com/api/projects/{project-name}". If you only have one Project in your Foundry Hub, or to target the default Project in your Hub, use the form "https://{ai-services-account-name}.services.ai.azure.com/api/projects/_project" |
| agent_name | path | Yes | string | The name of the agent to update. |
| api-version | query | Yes | string | The API version to use for this operation. Serialization: explode: false |
Request Body
Content-Type: application/json
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| description | string | A human-readable description of the agent. Constraints: maxLength: 512 |
No | |
| manifest_id | string | The manifest ID to import the agent version from. | Yes | |
| metadata | object | Set of 16 key-value pairs that can be attached to an object. This can be useful for storing additional information about the object in a structured format, and querying for objects via API or the dashboard. Keys are strings with a maximum length of 64 characters. Values are strings with a maximum length of 512 characters. |
No | |
| parameter_values | object | The inputs to the manifest that will result in a fully materialized Agent. | Yes |
Responses
Status Code: 200
Description: The request has succeeded.
| Content-Type | Type | Description |
|---|---|---|
| application/json | AgentObject |
Status Code: default
Description: An unexpected error response.
| Content-Type | Type | Description |
|---|---|---|
| application/json | ApiErrorResponse |
Agents - create agent version
POST {endpoint}/agents/{agent_name}/versions?api-version=v1
Create a new agent version.
URI Parameters
| Name | In | Required | Type | Description |
|---|---|---|---|---|
| endpoint | server | Yes | string | Foundry Project endpoint in the form "https://{ai-services-account-name}.services.ai.azure.com/api/projects/{project-name}". If you only have one Project in your Foundry Hub, or to target the default Project in your Hub, use the form "https://{ai-services-account-name}.services.ai.azure.com/api/projects/_project" |
| agent_name | path | Yes | string | The unique name that identifies the agent. Name can be used to retrieve/update/delete the agent. - Must start and end with alphanumeric characters, - Can contain hyphens in the middle - Must not exceed 63 characters. |
| api-version | query | Yes | string | The API version to use for this operation. Serialization: explode: false |
Request Header
| Name | Required | Type | Description |
|---|---|---|---|
| Foundry-Features | No | string Possible values: HostedAgents=V1Preview, WorkflowAgents=V1Preview |
A feature flag opt-in required when using preview operations or modifying persisted preview resources. |
Request Body
Content-Type: application/json
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| definition | AgentDefinition | Yes | ||
| └─ kind | AgentKind | Yes | ||
| └─ rai_config | RaiConfig | Configuration for Responsible AI (RAI) content filtering and safety features. | No | |
| description | string | A human-readable description of the agent. Constraints: maxLength: 512 |
No | |
| metadata | object | Set of 16 key-value pairs that can be attached to an object. This can be useful for storing additional information about the object in a structured format, and querying for objects via API or the dashboard. Keys are strings with a maximum length of 64 characters. Values are strings with a maximum length of 512 characters. |
No |
Responses
Status Code: 200
Description: The request has succeeded.
| Content-Type | Type | Description |
|---|---|---|
| application/json | AgentVersionObject |
Status Code: default
Description: An unexpected error response.
| Content-Type | Type | Description |
|---|---|---|
| application/json | ApiErrorResponse |
Agents - list agent versions
GET {endpoint}/agents/{agent_name}/versions?api-version=v1
Returns the list of versions of an agent.
URI Parameters
| Name | In | Required | Type | Description |
|---|---|---|---|---|
| endpoint | server | Yes | string | Foundry Project endpoint in the form "https://{ai-services-account-name}.services.ai.azure.com/api/projects/{project-name}". If you only have one Project in your Foundry Hub, or to target the default Project in your Hub, use the form "https://{ai-services-account-name}.services.ai.azure.com/api/projects/_project" |
| agent_name | path | Yes | string | The name of the agent to retrieve versions for. |
| limit | query | No | integer (int32) | A limit on the number of objects to be returned. Limit can range between 1 and 100, and the default is 20. Serialization: explode: false |
| order | query | No | string Possible values: asc, desc |
Sort order by the created_at timestamp of the objects. asc for ascending order anddescfor descending order. Serialization: explode: false |
| after | query | No | string | A cursor for use in pagination. after is an object ID that defines your place in the list.For instance, if you make a list request and receive 100 objects, ending with obj_foo, your subsequent call can include after=obj_foo in order to fetch the next page of the list. Serialization: explode: false |
| before | query | No | string | A cursor for use in pagination. before is an object ID that defines your place in the list.For instance, if you make a list request and receive 100 objects, ending with obj_foo, your subsequent call can include before=obj_foo in order to fetch the previous page of the list. Serialization: explode: false |
| api-version | query | Yes | string | The API version to use for this operation. Serialization: explode: false |
Responses
Status Code: 200
Description: The request has succeeded.
| Content-Type | Type | Description |
|---|---|---|
| application/json | object | The response data for a requested list of items. |
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| data | array of AgentVersionObject | The requested list of items. | Yes | |
| first_id | string | The first ID represented in this list. | No | |
| has_more | boolean | A value indicating whether there are additional values available not captured in this list. | Yes | |
| last_id | string | The last ID represented in this list. | No |
Status Code: default
Description: An unexpected error response.
| Content-Type | Type | Description |
|---|---|---|
| application/json | ApiErrorResponse |
Agents - get agent version
GET {endpoint}/agents/{agent_name}/versions/{agent_version}?api-version=v1
Retrieves a specific version of an agent.
URI Parameters
| Name | In | Required | Type | Description |
|---|---|---|---|---|
| endpoint | server | Yes | string | Foundry Project endpoint in the form "https://{ai-services-account-name}.services.ai.azure.com/api/projects/{project-name}". If you only have one Project in your Foundry Hub, or to target the default Project in your Hub, use the form "https://{ai-services-account-name}.services.ai.azure.com/api/projects/_project" |
| agent_name | path | Yes | string | The name of the agent to retrieve. |
| agent_version | path | Yes | string | The version of the agent to retrieve. |
| api-version | query | Yes | string | The API version to use for this operation. Serialization: explode: false |
Responses
Status Code: 200
Description: The request has succeeded.
| Content-Type | Type | Description |
|---|---|---|
| application/json | AgentVersionObject |
Status Code: default
Description: An unexpected error response.
| Content-Type | Type | Description |
|---|---|---|
| application/json | ApiErrorResponse |
Agents - delete agent version
DELETE {endpoint}/agents/{agent_name}/versions/{agent_version}?api-version=v1
Deletes a specific version of an agent.
URI Parameters
| Name | In | Required | Type | Description |
|---|---|---|---|---|
| endpoint | server | Yes | string | Foundry Project endpoint in the form "https://{ai-services-account-name}.services.ai.azure.com/api/projects/{project-name}". If you only have one Project in your Foundry Hub, or to target the default Project in your Hub, use the form "https://{ai-services-account-name}.services.ai.azure.com/api/projects/_project" |
| agent_name | path | Yes | string | The name of the agent to delete. |
| agent_version | path | Yes | string | The version of the agent to delete |
| api-version | query | Yes | string | The API version to use for this operation. Serialization: explode: false |
Responses
Status Code: 200
Description: The request has succeeded.
| Content-Type | Type | Description |
|---|---|---|
| application/json | DeleteAgentVersionResponse |
Status Code: default
Description: An unexpected error response.
| Content-Type | Type | Description |
|---|---|---|
| application/json | ApiErrorResponse |
Agents - create agent version from manifest
POST {endpoint}/agents/{agent_name}/versions:import?api-version=v1
Create a new agent version from a manifest.
URI Parameters
| Name | In | Required | Type | Description |
|---|---|---|---|---|
| endpoint | server | Yes | string | Foundry Project endpoint in the form "https://{ai-services-account-name}.services.ai.azure.com/api/projects/{project-name}". If you only have one Project in your Foundry Hub, or to target the default Project in your Hub, use the form "https://{ai-services-account-name}.services.ai.azure.com/api/projects/_project" |
| agent_name | path | Yes | string | The unique name that identifies the agent. Name can be used to retrieve/update/delete the agent. - Must start and end with alphanumeric characters, - Can contain hyphens in the middle - Must not exceed 63 characters. |
| api-version | query | Yes | string | The API version to use for this operation. Serialization: explode: false |
Request Body
Content-Type: application/json
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| description | string | A human-readable description of the agent. Constraints: maxLength: 512 |
No | |
| manifest_id | string | The manifest ID to import the agent version from. | Yes | |
| metadata | object | Set of 16 key-value pairs that can be attached to an object. This can be useful for storing additional information about the object in a structured format, and querying for objects via API or the dashboard. Keys are strings with a maximum length of 64 characters. Values are strings with a maximum length of 512 characters. |
No | |
| parameter_values | object | The inputs to the manifest that will result in a fully materialized Agent. | Yes |
Responses
Status Code: 200
Description: The request has succeeded.
| Content-Type | Type | Description |
|---|---|---|
| application/json | AgentVersionObject |
Status Code: default
Description: An unexpected error response.
| Content-Type | Type | Description |
|---|---|---|
| application/json | ApiErrorResponse |
Agents - create agent from manifest
POST {endpoint}/agents:import?api-version=v1
Creates an agent from a manifest.
URI Parameters
| Name | In | Required | Type | Description |
|---|---|---|---|---|
| endpoint | server | Yes | string | Foundry Project endpoint in the form "https://{ai-services-account-name}.services.ai.azure.com/api/projects/{project-name}". If you only have one Project in your Foundry Hub, or to target the default Project in your Hub, use the form "https://{ai-services-account-name}.services.ai.azure.com/api/projects/_project" |
| api-version | query | Yes | string | The API version to use for this operation. Serialization: explode: false |
Request Body
Content-Type: application/json
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| description | string | A human-readable description of the agent. Constraints: maxLength: 512 |
No | |
| manifest_id | string | The manifest ID to import the agent version from. | Yes | |
| metadata | object | Set of 16 key-value pairs that can be attached to an object. This can be useful for storing additional information about the object in a structured format, and querying for objects via API or the dashboard. Keys are strings with a maximum length of 64 characters. Values are strings with a maximum length of 512 characters. |
No | |
| name | string | The unique name that identifies the agent. Name can be used to retrieve/update/delete the agent. - Must start and end with alphanumeric characters, - Can contain hyphens in the middle - Must not exceed 63 characters. Constraints: maxLength: 63 |
Yes | |
| parameter_values | object | The inputs to the manifest that will result in a fully materialized Agent. | Yes |
Responses
Status Code: 200
Description: The request has succeeded.
| Content-Type | Type | Description |
|---|---|---|
| application/json | AgentObject |
Status Code: default
Description: An unexpected error response.
| Content-Type | Type | Description |
|---|---|---|
| application/json | ApiErrorResponse |
Components
A2APreviewTool
An agent implementing the A2A protocol.
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| agent_card_path | string | The path to the agent card relative to the base_url.If not provided, defaults to /.well-known/agent-card.json |
No | |
| base_url | string (uri) | Base URL of the agent. | No | |
| project_connection_id | string | The connection ID in the project for the A2A server. The connection stores authentication and other connection details needed to connect to the A2A server. |
No | |
| type | enum | The type of the tool. Always "a2a_preview.Possible values: a2a_preview |
Yes |
AISearchIndexResource
A AI Search Index resource.
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| filter | string | filter string for search resource. Learn more here. | No | |
| index_asset_id | string | Index asset id for search resource. | No | |
| index_name | string | The name of an index in an IndexResource attached to this agent. | No | |
| project_connection_id | string | An index connection ID in an IndexResource attached to this agent. | No | |
| query_type | AzureAISearchQueryType | Available query types for Azure AI Search tool. | No | |
| top_k | integer (int32) | Number of documents to retrieve from search and present to the model. | No |
AgentDefinition
Discriminator for AgentDefinition
This component uses the property kind to discriminate between different types:
| Type Value | Schema |
|---|---|
prompt |
PromptAgentDefinition |
workflow |
WorkflowAgentDefinition |
hosted |
HostedAgentDefinition |
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| kind | AgentKind | Yes | ||
| rai_config | RaiConfig | Configuration for Responsible AI (RAI) content filtering and safety features. | No | |
| └─ rai_policy_name | string | The name of the RAI policy to apply. | Yes |
AgentDefinitionOptInKeys
Feature opt-in keys for agent definition operations supporting hosted or workflow agents.
| Property | Value |
|---|---|
| Type | string |
| Values | HostedAgents=V1PreviewWorkflowAgents=V1Preview |
AgentKind
| Property | Value |
|---|---|
| Type | string |
| Values | prompthostedworkflow |
AgentObject
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| id | string | The unique identifier of the agent. | Yes | |
| name | string | The name of the agent. Constraints: maxLength: 63 |
Yes | |
| object | enum | The object type, which is always 'agent'. Possible values: agent |
Yes | |
| versions | object | The latest version of the agent. | Yes | |
| └─ latest | AgentVersionObject | Yes |
AgentProtocol
| Property | Value |
|---|---|
| Type | string |
| Values | activity_protocolresponses |
AgentVersionObject
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| created_at | FoundryTimestamp | Yes | ||
| definition | AgentDefinition | Yes | ||
| description | string | A human-readable description of the agent. Constraints: maxLength: 512 |
No | |
| id | string | The unique identifier of the agent version. | Yes | |
| metadata | object (nullable) | Set of 16 key-value pairs that can be attached to an object. This can be useful for storing additional information about the object in a structured format, and querying for objects via API or the dashboard. Keys are strings with a maximum length of 64 characters. Values are strings with a maximum length of 512 characters. |
Yes | |
| name | string | The name of the agent. Name can be used to retrieve/update/delete the agent. Constraints: maxLength: 256 |
Yes | |
| object | enum | The object type, which is always 'agent.version'. Possible values: agent.version |
Yes | |
| version | string | The version identifier of the agent. Agents are immutable and every update creates a new version while keeping the name same. | Yes |
ApiErrorResponse
Error response for API failures.
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| error | OpenAI.Error | Yes |
AzureAISearchQueryType
Available query types for Azure AI Search tool.
| Property | Value |
|---|---|
| Description | Available query types for Azure AI Search tool. |
| Type | string |
| Values | simplesemanticvectorvector_simple_hybridvector_semantic_hybrid |
AzureAISearchTool
The input definition information for an Azure AI search tool as used to configure an agent.
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| azure_ai_search | AzureAISearchToolResource | A set of index resources used by the azure_ai_search tool. |
Yes | |
| └─ indexes | array of AISearchIndexResource | The indices attached to this agent. There can be a maximum of 1 index resource attached to the agent. Constraints: maxItems: 1 |
Yes | |
| type | enum | The object type, which is always 'azure_ai_search'. Possible values: azure_ai_search |
Yes |
AzureAISearchToolResource
A set of index resources used by the azure_ai_search tool.
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| indexes | array of AISearchIndexResource | The indices attached to this agent. There can be a maximum of 1 index resource attached to the agent. Constraints: maxItems: 1 |
Yes |
AzureFunctionBinding
The structure for keeping storage queue name and URI.
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| storage_queue | AzureFunctionStorageQueue | The structure for keeping storage queue name and URI. | Yes | |
| └─ queue_name | string | The name of an Azure function storage queue. | Yes | |
| └─ queue_service_endpoint | string | URI to the Azure Storage Queue service allowing you to manipulate a queue. | Yes | |
| type | enum | The type of binding, which is always 'storage_queue'. Possible values: storage_queue |
Yes |
AzureFunctionDefinition
The definition of Azure function.
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| function | object | The definition of azure function and its parameters. | Yes | |
| └─ description | string | A description of what the function does, used by the model to choose when and how to call the function. | No | |
| └─ name | string | The name of the function to be called. | Yes | |
| └─ parameters | object | The parameters the functions accepts, described as a JSON Schema object. | Yes | |
| input_binding | AzureFunctionBinding | The structure for keeping storage queue name and URI. | Yes | |
| └─ storage_queue | AzureFunctionStorageQueue | Storage queue. | Yes | |
| └─ type | enum | The type of binding, which is always 'storage_queue'. Possible values: storage_queue |
Yes | |
| output_binding | AzureFunctionBinding | The structure for keeping storage queue name and URI. | Yes | |
| └─ storage_queue | AzureFunctionStorageQueue | Storage queue. | Yes | |
| └─ type | enum | The type of binding, which is always 'storage_queue'. Possible values: storage_queue |
Yes |
AzureFunctionStorageQueue
The structure for keeping storage queue name and URI.
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| queue_name | string | The name of an Azure function storage queue. | Yes | |
| queue_service_endpoint | string | URI to the Azure Storage Queue service allowing you to manipulate a queue. | Yes |
AzureFunctionTool
The input definition information for an Azure Function Tool, as used to configure an Agent.
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| azure_function | AzureFunctionDefinition | The definition of Azure function. | Yes | |
| └─ function | object | The definition of azure function and its parameters. | Yes | |
| └─ description | string | A description of what the function does, used by the model to choose when and how to call the function. | No | |
| └─ name | string | The name of the function to be called. | Yes | |
| └─ parameters | object | The parameters the functions accepts, described as a JSON Schema object. | Yes | |
| └─ input_binding | AzureFunctionBinding | Input storage queue. The queue storage trigger runs a function as messages are added to it. | Yes | |
| └─ output_binding | AzureFunctionBinding | Output storage queue. The function writes output to this queue when the input items are processed. | Yes | |
| type | enum | The object type, which is always 'browser_automation'. Possible values: azure_function |
Yes |
BingCustomSearchConfiguration
A bing custom search configuration.
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| count | integer (int64) | The number of search results to return in the bing api response | No | |
| freshness | string | Filter search results by a specific time range. See accepted values here. | No | |
| instance_name | string | Name of the custom configuration instance given to config. | Yes | |
| market | string | The market where the results come from. | No | |
| project_connection_id | string | Project connection id for grounding with bing search | Yes | |
| set_lang | string | The language to use for user interface strings when calling Bing API. | No |
BingCustomSearchPreviewTool
The input definition information for a Bing custom search tool as used to configure an agent.
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| bing_custom_search_preview | BingCustomSearchToolParameters | The bing custom search tool parameters. | Yes | |
| └─ search_configurations | array of BingCustomSearchConfiguration | The project connections attached to this tool. There can be a maximum of 1 connection resource attached to the tool. Constraints: maxItems: 1 |
Yes | |
| type | enum | The object type, which is always 'bing_custom_search_preview'. Possible values: bing_custom_search_preview |
Yes |
BingCustomSearchToolParameters
The bing custom search tool parameters.
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| search_configurations | array of BingCustomSearchConfiguration | The project connections attached to this tool. There can be a maximum of 1 connection resource attached to the tool. Constraints: maxItems: 1 |
Yes |
BingGroundingSearchConfiguration
Search configuration for Bing Grounding
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| count | integer (int64) | The number of search results to return in the bing api response | No | |
| freshness | string | Filter search results by a specific time range. See accepted values here. | No | |
| market | string | The market where the results come from. | No | |
| project_connection_id | string | Project connection id for grounding with bing search | Yes | |
| set_lang | string | The language to use for user interface strings when calling Bing API. | No |
BingGroundingSearchToolParameters
The bing grounding search tool parameters.
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| search_configurations | array of BingGroundingSearchConfiguration | The search configurations attached to this tool. There can be a maximum of 1 search configuration resource attached to the tool. Constraints: maxItems: 1 |
Yes |
BingGroundingTool
The input definition information for a bing grounding search tool as used to configure an agent.
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| bing_grounding | BingGroundingSearchToolParameters | The bing grounding search tool parameters. | Yes | |
| └─ search_configurations | array of BingGroundingSearchConfiguration | The search configurations attached to this tool. There can be a maximum of 1 search configuration resource attached to the tool. Constraints: maxItems: 1 |
Yes | |
| type | enum | The object type, which is always 'bing_grounding'. Possible values: bing_grounding |
Yes |
BrowserAutomationPreviewTool
The input definition information for a Browser Automation Tool, as used to configure an Agent.
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| browser_automation_preview | BrowserAutomationToolParameters | Definition of input parameters for the Browser Automation Tool. | Yes | |
| └─ connection | BrowserAutomationToolConnectionParameters | The project connection parameters associated with the Browser Automation Tool. | Yes | |
| type | enum | The object type, which is always 'browser_automation_preview'. Possible values: browser_automation_preview |
Yes |
BrowserAutomationToolConnectionParameters
Definition of input parameters for the connection used by the Browser Automation Tool.
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| project_connection_id | string | The ID of the project connection to your Azure Playwright resource. | Yes |
BrowserAutomationToolParameters
Definition of input parameters for the Browser Automation Tool.
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| connection | BrowserAutomationToolConnectionParameters | Definition of input parameters for the connection used by the Browser Automation Tool. | Yes | |
| └─ project_connection_id | string | The ID of the project connection to your Azure Playwright resource. | Yes |
CaptureStructuredOutputsTool
A tool for capturing structured outputs
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| outputs | StructuredOutputDefinition | A structured output that can be produced by the agent. | Yes | |
| └─ description | string | A description of the output to emit. Used by the model to determine when to emit the output. | Yes | |
| └─ name | string | The name of the structured output. | Yes | |
| └─ schema | object | The JSON schema for the structured output. | Yes | |
| └─ strict | boolean (nullable) | Whether to enforce strict validation. Default true. |
Yes | |
| type | enum | The type of the tool. Always capture_structured_outputs.Possible values: capture_structured_outputs |
Yes |
CreateAgentFromManifestRequest
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| description | string | A human-readable description of the agent. Constraints: maxLength: 512 |
No | |
| manifest_id | string | The manifest ID to import the agent version from. | Yes | |
| metadata | object | Set of 16 key-value pairs that can be attached to an object. This can be useful for storing additional information about the object in a structured format, and querying for objects via API or the dashboard. Keys are strings with a maximum length of 64 characters. Values are strings with a maximum length of 512 characters. |
No | |
| name | string | The unique name that identifies the agent. Name can be used to retrieve/update/delete the agent. - Must start and end with alphanumeric characters, - Can contain hyphens in the middle - Must not exceed 63 characters. Constraints: maxLength: 63 |
Yes | |
| parameter_values | object | The inputs to the manifest that will result in a fully materialized Agent. | Yes |
CreateAgentRequest
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| definition | AgentDefinition | Yes | ||
| └─ kind | AgentKind | Yes | ||
| └─ rai_config | RaiConfig | Configuration for Responsible AI (RAI) content filtering and safety features. | No | |
| description | string | A human-readable description of the agent. Constraints: maxLength: 512 |
No | |
| metadata | object | Set of 16 key-value pairs that can be attached to an object. This can be useful for storing additional information about the object in a structured format, and querying for objects via API or the dashboard. Keys are strings with a maximum length of 64 characters. Values are strings with a maximum length of 512 characters. |
No | |
| name | string | The unique name that identifies the agent. Name can be used to retrieve/update/delete the agent. - Must start and end with alphanumeric characters, - Can contain hyphens in the middle - Must not exceed 63 characters. Constraints: maxLength: 63 |
Yes |
CreateAgentVersionFromManifestRequest
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| description | string | A human-readable description of the agent. Constraints: maxLength: 512 |
No | |
| manifest_id | string | The manifest ID to import the agent version from. | Yes | |
| metadata | object | Set of 16 key-value pairs that can be attached to an object. This can be useful for storing additional information about the object in a structured format, and querying for objects via API or the dashboard. Keys are strings with a maximum length of 64 characters. Values are strings with a maximum length of 512 characters. |
No | |
| parameter_values | object | The inputs to the manifest that will result in a fully materialized Agent. | Yes |
CreateAgentVersionRequest
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| definition | AgentDefinition | Yes | ||
| └─ kind | AgentKind | Yes | ||
| └─ rai_config | RaiConfig | Configuration for Responsible AI (RAI) content filtering and safety features. | No | |
| description | string | A human-readable description of the agent. Constraints: maxLength: 512 |
No | |
| metadata | object | Set of 16 key-value pairs that can be attached to an object. This can be useful for storing additional information about the object in a structured format, and querying for objects via API or the dashboard. Keys are strings with a maximum length of 64 characters. Values are strings with a maximum length of 512 characters. |
No |
DeleteAgentResponse
A deleted agent Object
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| deleted | boolean | Whether the agent was successfully deleted. | Yes | |
| name | string | The name of the agent. | Yes | |
| object | enum | The object type. Always 'agent.deleted'. Possible values: agent.deleted |
Yes |
DeleteAgentVersionResponse
A deleted agent version Object
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| deleted | boolean | Whether the agent was successfully deleted. | Yes | |
| name | string | The name of the agent. | Yes | |
| object | enum | The object type. Always 'agent.version.deleted'. Possible values: agent.version.deleted |
Yes | |
| version | string | The version identifier of the agent. | Yes |
FabricDataAgentToolParameters
The fabric data agent tool parameters.
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| project_connections | array of ToolProjectConnection | The project connections attached to this tool. There can be a maximum of 1 connection resource attached to the tool. Constraints: maxItems: 1 |
No |
FoundryTimestamp
Type: integer
Format: unixtime
HostedAgentDefinition
The hosted agent definition.
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| container_protocol_versions | array of ProtocolVersionRecord | The protocols that the agent supports for ingress communication of the containers. | Yes | |
| cpu | string | The CPU configuration for the hosted agent. | Yes | |
| environment_variables | object | Environment variables to set in the hosted agent container. | No | |
| image | string | The image ID for the agent, applicable to image-based hosted agents. | No | |
| kind | enum | Possible values: hosted |
Yes | |
| memory | string | The memory configuration for the hosted agent. | Yes | |
| rai_config | RaiConfig | Configuration for Responsible AI (RAI) content filtering and safety features. | No | |
| └─ rai_policy_name | string | The name of the RAI policy to apply. | Yes | |
| tools | array of OpenAI.Tool | An array of tools the hosted agent's model may call while generating a response. You can specify which tool to use by setting the tool_choice parameter. |
No |
MemorySearchOptions
Memory search options.
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| max_memories | integer (int32) | Maximum number of memory items to return. | No |
MemorySearchPreviewTool
A tool for integrating memories into the agent.
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| memory_store_name | string | The name of the memory store to use. | Yes | |
| scope | string | The namespace used to group and isolate memories, such as a user ID. Limits which memories can be retrieved or updated. Use special variable {{$userId}} to scope memories to the current signed-in user. |
Yes | |
| search_options | MemorySearchOptions | Memory search options. | No | |
| └─ max_memories | integer (int32) | Maximum number of memory items to return. | No | |
| type | enum | The type of the tool. Always memory_search_preview.Possible values: memory_search_preview |
Yes | |
| update_delay | integer (int32) | Time to wait before updating memories after inactivity (seconds). Default 300. | No | 300 |
MicrosoftFabricPreviewTool
The input definition information for a Microsoft Fabric tool as used to configure an agent.
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| fabric_dataagent_preview | FabricDataAgentToolParameters | The fabric data agent tool parameters. | Yes | |
| └─ project_connections | array of ToolProjectConnection | The project connections attached to this tool. There can be a maximum of 1 connection resource attached to the tool. Constraints: maxItems: 1 |
No | |
| type | enum | The object type, which is always 'fabric_dataagent_preview'. Possible values: fabric_dataagent_preview |
Yes |
OpenAI.ApplyPatchToolParam
Apply patch tool
Allows the assistant to create, delete, or update files using unified diffs.
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| type | enum | The type of the tool. Always apply_patch.Possible values: apply_patch |
Yes | apply_patch |
OpenAI.ApproximateLocation
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| city | string (nullable) | No | ||
| country | string (nullable) | No | ||
| region | string (nullable) | No | ||
| timezone | string (nullable) | No | ||
| type | enum | The type of location approximation. Always approximate.Possible values: approximate |
Yes | approximate |
OpenAI.AutoCodeInterpreterToolParam
Automatic Code Interpreter Tool Parameters
Configuration for a code interpreter container. Optionally specify the IDs of the files to run the code on.
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| file_ids | array of string | An optional list of uploaded files to make available to your code. Constraints: maxItems: 50 |
No | |
| memory_limit | OpenAI.ContainerMemoryLimit (nullable) | No | ||
| network_policy | OpenAI.ContainerNetworkPolicyParam | Network access policy for the container. | No | |
| type | enum | Always auto.Possible values: auto |
Yes | auto |
OpenAI.CodeInterpreterTool
Code interpreter
A tool that runs Python code to help generate a response to a prompt.
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| container | string or OpenAI.AutoCodeInterpreterToolParam | The code interpreter container. Can be a container ID or an object that specifies uploaded file IDs to make available to your code, along with an optional memory_limit setting.If not provided, the service assumes auto. |
No | |
| type | enum | The type of the code interpreter tool. Always code_interpreter.Possible values: code_interpreter |
Yes |
OpenAI.ComparisonFilter
Comparison Filter
A filter used to compare a specified attribute key to a given value using a defined comparison operation.
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| key | string | The key to compare against the value. | Yes | |
| type | enum | Specifies the comparison operator: eq, ne, gt, gte, lt, lte, in, nin.- eq: equals- ne: not equal- gt: greater than- gte: greater than or equal- lt: less than- lte: less than or equal- in: in- nin: not inPossible values: eq, ne, gt, gte, lt, lte |
Yes | eq |
| value | string or OpenAI.numeric or boolean or array of string or OpenAI.numeric | The value to compare against the attribute key; supports string, number, or boolean types. | Yes |
OpenAI.CompoundFilter
Compound Filter
Combine multiple filters using and or or.
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| filters | array of OpenAI.ComparisonFilter or object | Array of filters to combine. Items can be ComparisonFilter or CompoundFilter. |
Yes | |
| type | enum | Type of operation: and or or.Possible values: and, or |
Yes |
OpenAI.ComputerEnvironment
| Property | Value |
|---|---|
| Type | string |
| Values | windowsmaclinuxubuntubrowser |
OpenAI.ComputerUsePreviewTool
Computer use preview
A tool that controls a virtual computer.
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| display_height | OpenAI.integer | Yes | ||
| display_width | OpenAI.integer | Yes | ||
| environment | OpenAI.ComputerEnvironment | Yes | ||
| type | enum | The type of the computer use tool. Always computer_use_preview.Possible values: computer_use_preview |
Yes | computer_use_preview |
OpenAI.ContainerAutoParam
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| file_ids | array of string | An optional list of uploaded files to make available to your code. Constraints: maxItems: 50 |
No | |
| memory_limit | OpenAI.ContainerMemoryLimit (nullable) | No | ||
| network_policy | OpenAI.ContainerNetworkPolicyParam | Network access policy for the container. | No | |
| skills | array of OpenAI.ContainerSkill | An optional list of skills referenced by id or inline data. Constraints: maxItems: 200 |
No | |
| type | enum | Automatically creates a container for this request Possible values: container_auto |
Yes | container_auto |
OpenAI.ContainerMemoryLimit
| Property | Value |
|---|---|
| Type | string |
| Values | 1g4g16g64g |
OpenAI.ContainerNetworkPolicyAllowlistParam
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| allowed_domains | array of string | A list of allowed domains when type is allowlist.Constraints: minItems: 1 |
Yes | |
| domain_secrets | array of OpenAI.ContainerNetworkPolicyDomainSecretParam | Optional domain-scoped secrets for allowlisted domains. Constraints: minItems: 1 |
No | |
| type | enum | Allow outbound network access only to specified domains. Always allowlist.Possible values: allowlist |
Yes | allowlist |
OpenAI.ContainerNetworkPolicyDisabledParam
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| type | enum | Disable outbound network access. Always disabled.Possible values: disabled |
Yes | disabled |
OpenAI.ContainerNetworkPolicyDomainSecretParam
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| domain | string | The domain associated with the secret. Constraints: minLength: 1 |
Yes | |
| name | string | The name of the secret to inject for the domain. Constraints: minLength: 1 |
Yes | |
| value | string | The secret value to inject for the domain. Constraints: minLength: 1, maxLength: 10485760 |
Yes |
OpenAI.ContainerNetworkPolicyParam
Network access policy for the container.
Discriminator for OpenAI.ContainerNetworkPolicyParam
This component uses the property type to discriminate between different types:
| Type Value | Schema |
|---|---|
disabled |
OpenAI.ContainerNetworkPolicyDisabledParam |
allowlist |
OpenAI.ContainerNetworkPolicyAllowlistParam |
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| type | OpenAI.ContainerNetworkPolicyParamType | Yes |
OpenAI.ContainerNetworkPolicyParamType
| Property | Value |
|---|---|
| Type | string |
| Values | disabledallowlist |
OpenAI.ContainerSkill
Discriminator for OpenAI.ContainerSkill
This component uses the property type to discriminate between different types:
| Type Value | Schema |
|---|---|
skill_reference |
OpenAI.SkillReferenceParam |
inline |
OpenAI.InlineSkillParam |
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| type | OpenAI.ContainerSkillType | Yes |
OpenAI.ContainerSkillType
| Property | Value |
|---|---|
| Type | string |
| Values | skill_referenceinline |
OpenAI.CustomGrammarFormatParam
Grammar format
A grammar defined by the user.
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| definition | string | The grammar definition. | Yes | |
| syntax | OpenAI.GrammarSyntax1 | Yes | ||
| type | enum | Grammar format. Always grammar.Possible values: grammar |
Yes | grammar |
OpenAI.CustomTextFormatParam
Text format
Unconstrained free-form text.
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| type | enum | Unconstrained text format. Always text.Possible values: text |
Yes | text |
OpenAI.CustomToolParam
Custom tool
A custom tool that processes input using a specified format. Learn more about custom tools
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| description | string | Optional description of the custom tool, used to provide more context. | No | |
| format | OpenAI.CustomToolParamFormat | The input format for the custom tool. Default is unconstrained text. | No | |
| └─ type | OpenAI.CustomToolParamFormatType | Yes | ||
| name | string | The name of the custom tool, used to identify it in tool calls. | Yes | |
| type | enum | The type of the custom tool. Always custom.Possible values: custom |
Yes | custom |
OpenAI.CustomToolParamFormat
The input format for the custom tool. Default is unconstrained text.
Discriminator for OpenAI.CustomToolParamFormat
This component uses the property type to discriminate between different types:
| Type Value | Schema |
|---|---|
text |
OpenAI.CustomTextFormatParam |
grammar |
OpenAI.CustomGrammarFormatParam |
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| type | OpenAI.CustomToolParamFormatType | Yes |
OpenAI.CustomToolParamFormatType
| Property | Value |
|---|---|
| Type | string |
| Values | textgrammar |
OpenAI.Error
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| additionalInfo | object | No | ||
| code | string (nullable) | Yes | ||
| debugInfo | object | No | ||
| details | array of OpenAI.Error | No | ||
| message | string | Yes | ||
| param | string (nullable) | No | ||
| type | string | No |
OpenAI.FileSearchTool
File search
A tool that searches for relevant content from uploaded files.
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| filters | OpenAI.Filters (nullable) | No | ||
| max_num_results | OpenAI.integer | No | ||
| ranking_options | OpenAI.RankingOptions | No | ||
| └─ hybrid_search | OpenAI.HybridSearchOptions | Weights that control how reciprocal rank fusion balances semantic embedding matches versus sparse keyword matches when hybrid search is enabled. | No | |
| └─ ranker | OpenAI.RankerVersionType | The ranker to use for the file search. | No | |
| └─ score_threshold | OpenAI.numeric | The score threshold for the file search, a number between 0 and 1. Numbers closer to 1 will attempt to return only the most relevant results, but may return fewer results. | No | |
| type | enum | The type of the file search tool. Always file_search.Possible values: file_search |
Yes | file_search |
| vector_store_ids | array of string | The IDs of the vector stores to search. | Yes |
OpenAI.Filters
Type: OpenAI.ComparisonFilter or OpenAI.CompoundFilter
OpenAI.FunctionShellToolParam
Shell tool
A tool that allows the model to execute shell commands.
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| environment | OpenAI.FunctionShellToolParamEnvironment (nullable) | No | ||
| └─ type | OpenAI.FunctionShellToolParamEnvironmentType | Yes | ||
| type | enum | The type of the shell tool. Always shell.Possible values: shell |
Yes | shell |
OpenAI.FunctionShellToolParamEnvironment
Discriminator for OpenAI.FunctionShellToolParamEnvironment
This component uses the property type to discriminate between different types:
| Type Value | Schema |
|---|---|
local |
OpenAI.FunctionShellToolParamEnvironmentLocalEnvironmentParam |
container_reference |
OpenAI.FunctionShellToolParamEnvironmentContainerReferenceParam |
container_auto |
OpenAI.ContainerAutoParam |
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| type | OpenAI.FunctionShellToolParamEnvironmentType | Yes |
OpenAI.FunctionShellToolParamEnvironmentContainerReferenceParam
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| container_id | string | The ID of the referenced container. | Yes | |
| type | enum | References a container created with the /v1/containers endpoint Possible values: container_reference |
Yes | container_reference |
OpenAI.FunctionShellToolParamEnvironmentLocalEnvironmentParam
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| skills | array of OpenAI.LocalSkillParam | An optional list of skills. Constraints: maxItems: 200 |
No | |
| type | enum | Use a local computer environment. Possible values: local |
Yes | local |
OpenAI.FunctionShellToolParamEnvironmentType
| Property | Value |
|---|---|
| Type | string |
| Values | container_autolocalcontainer_reference |
OpenAI.FunctionTool
Function
Defines a function in your own code the model can choose to call.
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| description | string (nullable) | No | ||
| name | string | The name of the function to call. | Yes | |
| parameters | object (nullable) | Yes | ||
| strict | boolean (nullable) | Yes | ||
| type | enum | The type of the function tool. Always function.Possible values: function |
Yes | function |
OpenAI.GrammarSyntax1
| Property | Value |
|---|---|
| Type | string |
| Values | larkregex |
OpenAI.HybridSearchOptions
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| embedding_weight | OpenAI.numeric | Yes | ||
| text_weight | OpenAI.numeric | Yes |
OpenAI.ImageGenActionEnum
| Property | Value |
|---|---|
| Type | string |
| Values | generateeditauto |
OpenAI.ImageGenTool
Image generation tool
A tool that generates images using the GPT image models.
Valid models:
gpt-image-1
gpt-image-1-mini
gpt-image-1.5
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| action | OpenAI.ImageGenActionEnum | No | ||
| background | enum | Background type for the generated image. One of transparent,opaque, or auto. Default: auto.Possible values: transparent, opaque, auto |
No | auto |
| input_fidelity | OpenAI.InputFidelity (nullable) | Control how much effort the model will exert to match the style and features, especially facial features, of input images. This parameter is only supported for gpt-image-1 and gpt-image-1.5 and later models, unsupported for gpt-image-1-mini. Supports high and low. Defaults to low. |
No | |
| input_image_mask | OpenAI.ImageGenToolInputImageMask | No | ||
| └─ file_id | string | No | ||
| └─ image_url | string (uri) | No | ||
| model | string (see valid models below) | No | ||
| moderation | enum | Moderation level for the generated image. Default: auto.Possible values: auto, low |
No | auto |
| output_compression | OpenAI.integer | Constraints: min: 0, max: 100 | No | 100 |
| output_format | enum | The output format of the generated image. One of png, webp, orjpeg. Default: png.Possible values: png, webp, jpeg |
No | png |
| partial_images | OpenAI.integer | Constraints: min: 0, max: 3 | No | |
| quality | enum | The quality of the generated image. One of low, medium, high,or auto. Default: auto.Possible values: low, medium, high, auto |
No | auto |
| size | enum | The size of the generated image. One of 1024x1024, 1024x1536,1536x1024, or auto. Default: auto.Possible values: 1024x1024, 1024x1536, 1536x1024, auto |
No | auto |
| type | enum | The type of the image generation tool. Always image_generation.Possible values: image_generation |
Yes | image_generation |
OpenAI.ImageGenToolInputImageMask
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| file_id | string | No | ||
| image_url | string (uri) | No |
OpenAI.InlineSkillParam
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| description | string | The description of the skill. | Yes | |
| name | string | The name of the skill. | Yes | |
| source | OpenAI.InlineSkillSourceParam | Inline skill payload | Yes | |
| └─ data | string | Base64-encoded skill zip bundle. Constraints: minLength: 1, maxLength: 70254592 |
Yes | |
| └─ media_type | enum | The media type of the inline skill payload. Must be application/zip.Possible values: application/zip |
Yes | application/zip |
| └─ type | enum | The type of the inline skill source. Must be base64.Possible values: base64 |
Yes | base64 |
| type | enum | Defines an inline skill for this request. Possible values: inline |
Yes | inline |
OpenAI.InlineSkillSourceParam
Inline skill payload
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| data | string | Base64-encoded skill zip bundle. Constraints: minLength: 1, maxLength: 70254592 |
Yes | |
| media_type | enum | The media type of the inline skill payload. Must be application/zip.Possible values: application/zip |
Yes | application/zip |
| type | enum | The type of the inline skill source. Must be base64.Possible values: base64 |
Yes | base64 |
OpenAI.InputFidelity
Control how much effort the model will exert to match the style and features, especially facial features, of input images. This parameter is only supported for gpt-image-1 and gpt-image-1.5 and later models, unsupported for gpt-image-1-mini. Supports high and low. Defaults to low.
| Property | Value |
|---|---|
| Type | string |
| Values | highlow |
OpenAI.LocalShellToolParam
Local shell tool
A tool that allows the model to execute shell commands in a local environment.
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| type | enum | The type of the local shell tool. Always local_shell.Possible values: local_shell |
Yes | local_shell |
OpenAI.LocalSkillParam
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| description | string | The description of the skill. | Yes | |
| name | string | The name of the skill. | Yes | |
| path | string | The path to the directory containing the skill. | Yes |
OpenAI.MCPTool
MCP tool
Give the model access to additional tools via remote Model Context Protocol (MCP) servers.
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| allowed_tools | array of string or OpenAI.MCPToolFilter | No | ||
| authorization | string | An OAuth access token that can be used with a remote MCP server, either with a custom MCP server URL or a service connector. Your application must handle the OAuth authorization flow and provide the token here. |
No | |
| connector_id | enum | Identifier for service connectors, like those available in ChatGPT. One ofserver_url or connector_id must be provided. Learn more about serviceconnectors here. Currently supported connector_id values are:- Dropbox: connector_dropbox- Gmail: connector_gmail- Google Calendar: connector_googlecalendar- Google Drive: connector_googledrive- Microsoft Teams: connector_microsoftteams- Outlook Calendar: connector_outlookcalendar- Outlook Email: connector_outlookemail- SharePoint: connector_sharepointPossible values: connector_dropbox, connector_gmail, connector_googlecalendar, connector_googledrive, connector_microsoftteams, connector_outlookcalendar, connector_outlookemail, connector_sharepoint |
No | |
| headers | object (nullable) | No | ||
| project_connection_id | string | The connection ID in the project for the MCP server. The connection stores authentication and other connection details needed to connect to the MCP server. | No | |
| require_approval | OpenAI.MCPToolRequireApproval or string | No | ||
| server_description | string | Optional description of the MCP server, used to provide more context. | No | |
| server_label | string | A label for this MCP server, used to identify it in tool calls. | Yes | |
| server_url | string (uri) | The URL for the MCP server. One of server_url or connector_id must beprovided. |
No | |
| type | enum | The type of the MCP tool. Always mcp.Possible values: mcp |
Yes |
OpenAI.MCPToolFilter
MCP tool filter
A filter object to specify which tools are allowed.
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| read_only | boolean | Indicates whether or not a tool modifies data or is read-only. If an MCP server is annotated with readOnlyHint,it will match this filter. |
No | |
| tool_names | array of string | List of allowed tool names. | No |
OpenAI.MCPToolRequireApproval
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| always | OpenAI.MCPToolFilter | A filter object to specify which tools are allowed. | No | |
| never | OpenAI.MCPToolFilter | A filter object to specify which tools are allowed. | No |
OpenAI.RankerVersionType
| Property | Value |
|---|---|
| Type | string |
| Values | autodefault-2024-11-15 |
OpenAI.RankingOptions
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| hybrid_search | OpenAI.HybridSearchOptions | No | ||
| └─ embedding_weight | OpenAI.numeric | The weight of the embedding in the reciprocal ranking fusion. | Yes | |
| └─ text_weight | OpenAI.numeric | The weight of the text in the reciprocal ranking fusion. | Yes | |
| ranker | OpenAI.RankerVersionType | No | ||
| score_threshold | OpenAI.numeric | No |
OpenAI.Reasoning
Reasoning
gpt-5 and o-series models only Configuration options for reasoning models.
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| effort | OpenAI.ReasoningEffort | Constrains effort on reasoning for reasoning models. Currently supported values are none, minimal, low, medium, high, and xhigh. Reducingreasoning effort can result in faster responses and fewer tokens used on reasoning in a response. - gpt-5.1 defaults to none, which does not perform reasoning. The supported reasoning values for gpt-5.1 are none, low, medium, and high. Tool calls are supported for all reasoning values in gpt-5.1.- All models before gpt-5.1 default to medium reasoning effort, and do not support none.- The gpt-5-pro model defaults to (and only supports) high reasoning effort.- xhigh is supported for all models after gpt-5.1-codex-max. |
No | |
| generate_summary | enum (nullable) | Possible values: auto, concise, detailed |
No | |
| summary | enum (nullable) | Possible values: auto, concise, detailed |
No |
OpenAI.ReasoningEffort
Constrains effort on reasoning for
reasoning models.
Currently supported values are none, minimal, low, medium, high, and xhigh. Reducing
reasoning effort can result in faster responses and fewer tokens used
on reasoning in a response.
gpt-5.1defaults tonone, which does not perform reasoning. The supported reasoning values forgpt-5.1arenone,low,medium, andhigh. Tool calls are supported for all reasoning values in gpt-5.1.- All models before
gpt-5.1default tomediumreasoning effort, and do not supportnone. - The
gpt-5-promodel defaults to (and only supports)highreasoning effort. xhighis supported for all models aftergpt-5.1-codex-max.
| Property | Value |
|---|---|
| Type | string |
| Nullable | Yes |
| Values | noneminimallowmediumhighxhigh |
OpenAI.ResponseFormatJsonSchemaSchema
JSON schema
The schema for the response format, described as a JSON Schema object. Learn how to build JSON schemas here.
Type: object
OpenAI.SearchContextSize
| Property | Value |
|---|---|
| Type | string |
| Values | lowmediumhigh |
OpenAI.SkillReferenceParam
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| skill_id | string | The ID of the referenced skill. Constraints: minLength: 1, maxLength: 64 |
Yes | |
| type | enum | References a skill created with the /v1/skills endpoint. Possible values: skill_reference |
Yes | skill_reference |
| version | string | Optional skill version. Use a positive integer or 'latest'. Omit for default. | No |
OpenAI.SpecificApplyPatchParam
Specific apply patch tool choice
Forces the model to call the apply_patch tool when executing a tool call.
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| type | enum | The tool to call. Always apply_patch.Possible values: apply_patch |
Yes | apply_patch |
OpenAI.SpecificFunctionShellParam
Specific shell tool choice
Forces the model to call the shell tool when a tool call is required.
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| type | enum | The tool to call. Always shell.Possible values: shell |
Yes | shell |
OpenAI.TextResponseFormatConfiguration
An object specifying the format that the model must output.
Configuring { "type": "json_schema" } enables Structured Outputs,
which ensures the model will match your supplied JSON schema. Learn more in the
The default format is { "type": "text" } with no additional options.
Not recommended for gpt-4o and newer models:
Setting to { "type": "json_object" } enables the older JSON mode, which
ensures the message the model generates is valid JSON. Using json_schema
is preferred for models that support it.
Discriminator for OpenAI.TextResponseFormatConfiguration
This component uses the property type to discriminate between different types:
| Type Value | Schema |
|---|---|
json_schema |
OpenAI.TextResponseFormatJsonSchema |
text |
OpenAI.TextResponseFormatConfigurationResponseFormatText |
json_object |
OpenAI.TextResponseFormatConfigurationResponseFormatJsonObject |
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| type | OpenAI.TextResponseFormatConfigurationType | Yes |
OpenAI.TextResponseFormatConfigurationResponseFormatJsonObject
JSON object
JSON object response format. An older method of generating JSON responses.
Using json_schema is recommended for models that support it. Note that the
model will not generate JSON without a system or user message instructing it
to do so.
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| type | enum | The type of response format being defined. Always json_object.Possible values: json_object |
Yes |
OpenAI.TextResponseFormatConfigurationResponseFormatText
Text
Default response format. Used to generate text responses.
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| type | enum | The type of response format being defined. Always text.Possible values: text |
Yes |
OpenAI.TextResponseFormatConfigurationType
| Property | Value |
|---|---|
| Type | string |
| Values | textjson_schemajson_object |
OpenAI.TextResponseFormatJsonSchema
JSON schema
JSON Schema response format. Used to generate structured JSON responses.
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| description | string | A description of what the response format is for, used by the model to determine how to respond in the format. |
No | |
| name | string | The name of the response format. Must be a-z, A-Z, 0-9, or contain underscores and dashes, with a maximum length of 64. |
Yes | |
| schema | OpenAI.ResponseFormatJsonSchemaSchema | The schema for the response format, described as a JSON Schema object. Learn how to build JSON schemas here. |
Yes | |
| strict | boolean (nullable) | No | ||
| type | enum | The type of response format being defined. Always json_schema.Possible values: json_schema |
Yes |
OpenAI.Tool
A tool that can be used to generate a response.
Discriminator for OpenAI.Tool
This component uses the property type to discriminate between different types:
| Type Value | Schema |
|---|---|
bing_grounding |
BingGroundingTool |
fabric_dataagent_preview |
MicrosoftFabricPreviewTool |
sharepoint_grounding_preview |
SharepointPreviewTool |
azure_ai_search |
AzureAISearchTool |
openapi |
OpenApiTool |
bing_custom_search_preview |
BingCustomSearchPreviewTool |
browser_automation_preview |
BrowserAutomationPreviewTool |
azure_function |
AzureFunctionTool |
capture_structured_outputs |
CaptureStructuredOutputsTool |
a2a_preview |
A2APreviewTool |
memory_search_preview |
MemorySearchPreviewTool |
code_interpreter |
OpenAI.CodeInterpreterTool |
function |
OpenAI.FunctionTool |
file_search |
OpenAI.FileSearchTool |
computer_use_preview |
OpenAI.ComputerUsePreviewTool |
web_search |
OpenAI.WebSearchTool |
mcp |
OpenAI.MCPTool |
image_generation |
OpenAI.ImageGenTool |
local_shell |
OpenAI.LocalShellToolParam |
shell |
OpenAI.FunctionShellToolParam |
custom |
OpenAI.CustomToolParam |
web_search_preview |
OpenAI.WebSearchPreviewTool |
apply_patch |
OpenAI.ApplyPatchToolParam |
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| type | OpenAI.ToolType | Yes |
OpenAI.ToolChoiceAllowed
Allowed tools
Constrains the tools available to the model to a pre-defined set.
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| mode | enum | Constrains the tools available to the model to a pre-defined set.auto allows the model to pick from among the allowed tools and generate amessage. required requires the model to call one or more of the allowed tools.Possible values: auto, required |
Yes | |
| tools | array of object | A list of tool definitions that the model should be allowed to call. For the Responses API, the list of tool definitions might look like: json<br> [<br> { "type": "function", "name": "get_weather" },<br> { "type": "mcp", "server_label": "deepwiki" },<br> { "type": "image_generation" }<br> ]<br> |
Yes | |
| type | enum | Allowed tool configuration type. Always allowed_tools.Possible values: allowed_tools |
Yes |
OpenAI.ToolChoiceCodeInterpreter
Indicates that the model should use a built-in tool to generate a response. Learn more about built-in tools.
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| type | enum | Possible values: code_interpreter |
Yes |
OpenAI.ToolChoiceComputerUsePreview
Indicates that the model should use a built-in tool to generate a response. Learn more about built-in tools.
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| type | enum | Possible values: computer_use_preview |
Yes |
OpenAI.ToolChoiceCustom
Custom tool
Use this option to force the model to call a specific custom tool.
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| name | string | The name of the custom tool to call. | Yes | |
| type | enum | For custom tool calling, the type is always custom.Possible values: custom |
Yes |
OpenAI.ToolChoiceFileSearch
Indicates that the model should use a built-in tool to generate a response. Learn more about built-in tools.
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| type | enum | Possible values: file_search |
Yes |
OpenAI.ToolChoiceFunction
Function tool
Use this option to force the model to call a specific function.
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| name | string | The name of the function to call. | Yes | |
| type | enum | For function calling, the type is always function.Possible values: function |
Yes |
OpenAI.ToolChoiceImageGeneration
Indicates that the model should use a built-in tool to generate a response. Learn more about built-in tools.
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| type | enum | Possible values: image_generation |
Yes |
OpenAI.ToolChoiceMCP
MCP tool
Use this option to force the model to call a specific tool on a remote MCP server.
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| name | string (nullable) | No | ||
| server_label | string | The label of the MCP server to use. | Yes | |
| type | enum | For MCP tools, the type is always mcp.Possible values: mcp |
Yes |
OpenAI.ToolChoiceParam
How the model should select which tool (or tools) to use when generating
a response. See the tools parameter to see how to specify which tools
the model can call.
Discriminator for OpenAI.ToolChoiceParam
This component uses the property type to discriminate between different types:
| Type Value | Schema |
|---|---|
allowed_tools |
OpenAI.ToolChoiceAllowed |
function |
OpenAI.ToolChoiceFunction |
mcp |
OpenAI.ToolChoiceMCP |
custom |
OpenAI.ToolChoiceCustom |
apply_patch |
OpenAI.SpecificApplyPatchParam |
shell |
OpenAI.SpecificFunctionShellParam |
file_search |
OpenAI.ToolChoiceFileSearch |
web_search_preview |
OpenAI.ToolChoiceWebSearchPreview |
computer_use_preview |
OpenAI.ToolChoiceComputerUsePreview |
web_search_preview_2025_03_11 |
OpenAI.ToolChoiceWebSearchPreview20250311 |
image_generation |
OpenAI.ToolChoiceImageGeneration |
code_interpreter |
OpenAI.ToolChoiceCodeInterpreter |
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| type | OpenAI.ToolChoiceParamType | Yes |
OpenAI.ToolChoiceParamType
| Property | Value |
|---|---|
| Type | string |
| Values | allowed_toolsfunctionmcpcustomapply_patchshellfile_searchweb_search_previewcomputer_use_previewweb_search_preview_2025_03_11image_generationcode_interpreter |
OpenAI.ToolChoiceWebSearchPreview
Indicates that the model should use a built-in tool to generate a response. Learn more about built-in tools.
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| type | enum | Possible values: web_search_preview |
Yes |
OpenAI.ToolChoiceWebSearchPreview20250311
Indicates that the model should use a built-in tool to generate a response. Learn more about built-in tools.
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| type | enum | Possible values: web_search_preview_2025_03_11 |
Yes |
OpenAI.ToolType
| Property | Value |
|---|---|
| Type | string |
| Values | functionfile_searchcomputer_use_previewweb_searchmcpcode_interpreterimage_generationlocal_shellshellcustomweb_search_previewapply_patcha2a_previewbing_custom_search_previewbrowser_automation_previewfabric_dataagent_previewsharepoint_grounding_previewmemory_search_previewazure_ai_searchazure_functionbing_groundingcapture_structured_outputsopenapi |
OpenAI.WebSearchApproximateLocation
Web search approximate location
The approximate location of the user.
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| city | string (nullable) | No | ||
| country | string (nullable) | No | ||
| region | string (nullable) | No | ||
| timezone | string (nullable) | No | ||
| type | enum | The type of location approximation. Always approximate.Possible values: approximate |
Yes | approximate |
OpenAI.WebSearchPreviewTool
Web search preview
This tool searches the web for relevant results to use in a response. Learn more about the web search tool.
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| search_context_size | OpenAI.SearchContextSize | No | ||
| type | enum | The type of the web search tool. One of web_search_preview or web_search_preview_2025_03_11.Possible values: web_search_preview |
Yes | web_search_preview |
| user_location | OpenAI.ApproximateLocation (nullable) | No | ||
| └─ city | string (nullable) | No | ||
| └─ country | string (nullable) | No | ||
| └─ region | string (nullable) | No | ||
| └─ timezone | string (nullable) | No | ||
| └─ type | enum | The type of location approximation. Always approximate.Possible values: approximate |
Yes | approximate |
OpenAI.WebSearchTool
Web search
Search the Internet for sources related to the prompt. Learn more about the web search tool.
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| custom_search_configuration | WebSearchConfiguration | A web search configuration for bing custom search | No | |
| └─ instance_name | string | Name of the custom configuration instance given to config. | Yes | |
| └─ project_connection_id | string | Project connection id for grounding with bing custom search | Yes | |
| filters | OpenAI.WebSearchToolFilters (nullable) | No | ||
| └─ allowed_domains | array of string (nullable) | No | ||
| search_context_size | enum | High level guidance for the amount of context window space to use for the search. One of low, medium, or high. medium is the default.Possible values: low, medium, high |
No | medium |
| type | enum | The type of the web search tool. One of web_search or web_search_2025_08_26.Possible values: web_search |
Yes | web_search |
| user_location | OpenAI.WebSearchApproximateLocation (nullable) | The approximate location of the user. | No | |
| └─ city | string (nullable) | No | ||
| └─ country | string (nullable) | No | ||
| └─ region | string (nullable) | No | ||
| └─ timezone | string (nullable) | No | ||
| └─ type | enum | The type of location approximation. Always approximate.Possible values: approximate |
Yes | approximate |
OpenAI.WebSearchToolFilters
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| allowed_domains | array of string (nullable) | No |
OpenAI.integer
Type: integer
Format: int64
OpenAI.numeric
Type: number
Format: double
OpenApiAnonymousAuthDetails
Security details for OpenApi anonymous authentication
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| type | enum | The object type, which is always 'anonymous'. Possible values: anonymous |
Yes |
OpenApiAuthDetails
authentication details for OpenApiFunctionDefinition
Discriminator for OpenApiAuthDetails
This component uses the property type to discriminate between different types:
| Type Value | Schema |
|---|---|
anonymous |
OpenApiAnonymousAuthDetails |
project_connection |
OpenApiProjectConnectionAuthDetails |
managed_identity |
OpenApiManagedAuthDetails |
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| type | OpenApiAuthType | Authentication type for OpenApi endpoint. Allowed types are: - Anonymous (no authentication required) - Project Connection (requires project_connection_id to endpoint, as setup in AI Foundry) - Managed_Identity (requires audience for identity based auth) |
Yes |
OpenApiAuthType
Authentication type for OpenApi endpoint. Allowed types are:
- Anonymous (no authentication required)
- Project Connection (requires project_connection_id to endpoint, as setup in AI Foundry)
- Managed_Identity (requires audience for identity based auth)
| Property | Value |
|---|---|
| Description | Authentication type for OpenApi endpoint. Allowed types are: - Anonymous (no authentication required) - Project Connection (requires project_connection_id to endpoint, as setup in AI Foundry) - Managed_Identity (requires audience for identity based auth) |
| Type | string |
| Values | anonymousproject_connectionmanaged_identity |
OpenApiFunctionDefinition
The input definition information for an openapi function.
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| auth | OpenApiAuthDetails | authentication details for OpenApiFunctionDefinition | Yes | |
| └─ type | OpenApiAuthType | The type of authentication, must be anonymous/project_connection/managed_identity | Yes | |
| default_params | array of string | List of OpenAPI spec parameters that will use user-provided defaults | No | |
| description | string | A description of what the function does, used by the model to choose when and how to call the function. | No | |
| functions | array of object (read-only) | List of function definitions used by OpenApi tool | No | |
| name | string | The name of the function to be called. | Yes | |
| spec | object | The openapi function shape, described as a JSON Schema object. | Yes |
OpenApiManagedAuthDetails
Security details for OpenApi managed_identity authentication
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| security_scheme | OpenApiManagedSecurityScheme | Security scheme for OpenApi managed_identity authentication | Yes | |
| └─ audience | string | Authentication scope for managed_identity auth type | Yes | |
| type | enum | The object type, which is always 'managed_identity'. Possible values: managed_identity |
Yes |
OpenApiManagedSecurityScheme
Security scheme for OpenApi managed_identity authentication
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| audience | string | Authentication scope for managed_identity auth type | Yes |
OpenApiProjectConnectionAuthDetails
Security details for OpenApi project connection authentication
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| security_scheme | OpenApiProjectConnectionSecurityScheme | Security scheme for OpenApi managed_identity authentication | Yes | |
| └─ project_connection_id | string | Project connection id for Project Connection auth type | Yes | |
| type | enum | The object type, which is always 'project_connection'. Possible values: project_connection |
Yes |
OpenApiProjectConnectionSecurityScheme
Security scheme for OpenApi managed_identity authentication
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| project_connection_id | string | Project connection id for Project Connection auth type | Yes |
OpenApiTool
The input definition information for an OpenAPI tool as used to configure an agent.
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| openapi | OpenApiFunctionDefinition | The input definition information for an openapi function. | Yes | |
| └─ auth | OpenApiAuthDetails | Open API authentication details | Yes | |
| └─ default_params | array of string | List of OpenAPI spec parameters that will use user-provided defaults | No | |
| └─ description | string | A description of what the function does, used by the model to choose when and how to call the function. | No | |
| └─ functions | array of object (read-only) | List of function definitions used by OpenApi tool | No | |
| └─ description | string | A description of what the function does, used by the model to choose when and how to call the function. | No | |
| └─ name | string | The name of the function to be called. | Yes | |
| └─ parameters | object | The parameters the functions accepts, described as a JSON Schema object. | Yes | |
| └─ name | string | The name of the function to be called. | Yes | |
| └─ spec | object | The openapi function shape, described as a JSON Schema object. | Yes | |
| type | enum | The object type, which is always 'openapi'. Possible values: openapi |
Yes |
PageOrder
| Property | Value |
|---|---|
| Type | string |
| Values | ascdesc |
PromptAgentDefinition
The prompt agent definition
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| instructions | string (nullable) | A system (or developer) message inserted into the model's context. | No | |
| kind | enum | Possible values: prompt |
Yes | |
| model | string | The model deployment to use for this agent. | Yes | |
| rai_config | RaiConfig | Configuration for Responsible AI (RAI) content filtering and safety features. | No | |
| └─ rai_policy_name | string | The name of the RAI policy to apply. | Yes | |
| reasoning | OpenAI.Reasoning (nullable) | gpt-5 and o-series models only Configuration options for reasoning models. |
No | |
| └─ effort | OpenAI.ReasoningEffort | Constrains effort on reasoning for reasoning models. Currently supported values are none, minimal, low, medium, high, and xhigh. Reducingreasoning effort can result in faster responses and fewer tokens used on reasoning in a response. - gpt-5.1 defaults to none, which does not perform reasoning. The supported reasoning values for gpt-5.1 are none, low, medium, and high. Tool calls are supported for all reasoning values in gpt-5.1.- All models before gpt-5.1 default to medium reasoning effort, and do not support none.- The gpt-5-pro model defaults to (and only supports) high reasoning effort.- xhigh is supported for all models after gpt-5.1-codex-max. |
No | |
| └─ generate_summary | enum (nullable) | Possible values: auto, concise, detailed |
No | |
| └─ summary | enum (nullable) | Possible values: auto, concise, detailed |
No | |
| structured_inputs | object | Set of structured inputs that can participate in prompt template substitution or tool argument bindings. | No | |
| temperature | number (float) (nullable) | What sampling temperature to use, between 0 and 2. Higher values like 0.8 will make the output more random, while lower values like 0.2 will make it more focused and deterministic. We generally recommend altering this or top_p but not both.Constraints: min: 0, max: 2 |
No | 1 |
| text | PromptAgentDefinitionTextOptions | Configuration options for a text response from the model. Can be plain text or structured JSON data. | No | |
| └─ format | OpenAI.TextResponseFormatConfiguration | An object specifying the format that the model must output. Configuring { "type": "json_schema" } enables Structured Outputs,which ensures the model will match your supplied JSON schema. Learn more in the The default format is { "type": "text" } with no additional options.Not recommended for gpt-4o and newer models: Setting to { "type": "json_object" } enables the older JSON mode, whichensures the message the model generates is valid JSON. Using json_schemais preferred for models that support it. |
No | |
| tool_choice | string or OpenAI.ToolChoiceParam | How the model should select which tool (or tools) to use when generating a response. See the tools parameter to see how to specify which tools the model can call. |
No | |
| tools | array of OpenAI.Tool | An array of tools the model may call while generating a response. You can specify which tool to use by setting the tool_choice parameter. |
No | |
| top_p | number (float) (nullable) | An alternative to sampling with temperature, called nucleus sampling, where the model considers the results of the tokens with top_p probability mass. So 0.1 means only the tokens comprising the top 10% probability mass are considered. We generally recommend altering this or temperature but not both.Constraints: min: 0, max: 1 |
No | 1 |
PromptAgentDefinitionTextOptions
Configuration options for a text response from the model. Can be plain text or structured JSON data.
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| format | OpenAI.TextResponseFormatConfiguration | An object specifying the format that the model must output. Configuring { "type": "json_schema" } enables Structured Outputs,which ensures the model will match your supplied JSON schema. Learn more in the The default format is { "type": "text" } with no additional options.Not recommended for gpt-4o and newer models: Setting to { "type": "json_object" } enables the older JSON mode, whichensures the message the model generates is valid JSON. Using json_schemais preferred for models that support it. |
No |
ProtocolVersionRecord
A record mapping for a single protocol and its version.
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| protocol | AgentProtocol | Yes | ||
| version | string | The version string for the protocol, e.g. 'v0.1.1'. | Yes |
RaiConfig
Configuration for Responsible AI (RAI) content filtering and safety features.
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| rai_policy_name | string | The name of the RAI policy to apply. | Yes |
SharepointGroundingToolParameters
The sharepoint grounding tool parameters.
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| project_connections | array of ToolProjectConnection | The project connections attached to this tool. There can be a maximum of 1 connection resource attached to the tool. Constraints: maxItems: 1 |
No |
SharepointPreviewTool
The input definition information for a sharepoint tool as used to configure an agent.
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| sharepoint_grounding_preview | SharepointGroundingToolParameters | The sharepoint grounding tool parameters. | Yes | |
| └─ project_connections | array of ToolProjectConnection | The project connections attached to this tool. There can be a maximum of 1 connection resource attached to the tool. Constraints: maxItems: 1 |
No | |
| type | enum | The object type, which is always 'sharepoint_grounding_preview'. Possible values: sharepoint_grounding_preview |
Yes |
StructuredInputDefinition
An structured input that can participate in prompt template substitutions and tool argument binding.
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| default_value | The default value for the input if no run-time value is provided. | No | ||
| description | string | A human-readable description of the input. | No | |
| required | boolean | Whether the input property is required when the agent is invoked. | No | False |
| schema | object | The JSON schema for the structured input (optional). | No |
StructuredOutputDefinition
A structured output that can be produced by the agent.
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| description | string | A description of the output to emit. Used by the model to determine when to emit the output. | Yes | |
| name | string | The name of the structured output. | Yes | |
| schema | object | The JSON schema for the structured output. | Yes | |
| strict | boolean (nullable) | Whether to enforce strict validation. Default true. |
Yes |
ToolProjectConnection
A project connection resource.
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| project_connection_id | string | A project connection in a ToolProjectConnectionList attached to this tool. | Yes |
UpdateAgentFromManifestRequest
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| description | string | A human-readable description of the agent. Constraints: maxLength: 512 |
No | |
| manifest_id | string | The manifest ID to import the agent version from. | Yes | |
| metadata | object | Set of 16 key-value pairs that can be attached to an object. This can be useful for storing additional information about the object in a structured format, and querying for objects via API or the dashboard. Keys are strings with a maximum length of 64 characters. Values are strings with a maximum length of 512 characters. |
No | |
| parameter_values | object | The inputs to the manifest that will result in a fully materialized Agent. | Yes |
UpdateAgentRequest
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| definition | AgentDefinition | Yes | ||
| └─ kind | AgentKind | Yes | ||
| └─ rai_config | RaiConfig | Configuration for Responsible AI (RAI) content filtering and safety features. | No | |
| description | string | A human-readable description of the agent. Constraints: maxLength: 512 |
No | |
| metadata | object | Set of 16 key-value pairs that can be attached to an object. This can be useful for storing additional information about the object in a structured format, and querying for objects via API or the dashboard. Keys are strings with a maximum length of 64 characters. Values are strings with a maximum length of 512 characters. |
No |
WebSearchConfiguration
A web search configuration for bing custom search
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| instance_name | string | Name of the custom configuration instance given to config. | Yes | |
| project_connection_id | string | Project connection id for grounding with bing custom search | Yes |
WorkflowAgentDefinition
The workflow agent definition.
| Name | Type | Description | Required | Default |
|---|---|---|---|---|
| kind | enum | Possible values: workflow |
Yes | |
| rai_config | RaiConfig | Configuration for Responsible AI (RAI) content filtering and safety features. | No | |
| └─ rai_policy_name | string | The name of the RAI policy to apply. | Yes | |
| workflow | string | The CSDL YAML definition of the workflow. | No |